Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports Telerik.OpenAccess
Imports PersistentClasses

Partial Public Class InheritanceAndPlymorphism
	Inherits System.Web.UI.UserControl
	Protected Sub RadGrid1_NeedDataSource(ByVal source As Object, ByVal e As Telerik.Web.UI.GridNeedDataSourceEventArgs)
		Dim query As String = String.Empty
		Dim scope As IObjectScope = ObjectScopeProvider1.ObjectScope()
		Dim queryResult As Object = Nothing

		If RadComboBox1.SelectedValue = "0" Then
			query = "SELECT * FROM ProductExtent AS x"
			' LINQ statement: from x in scope.Extent<Product>() select x;
			queryResult = scope.GetOqlQuery(Of PersistentClasses.Product)(query).ExecuteBindingList()
		ElseIf RadComboBox1.SelectedValue = "1" Then
			query = "SELECT * FROM BookExtent AS x"
			' LINQ statement: from x in scope.Extent<Book>() select x;
			queryResult = scope.GetOqlQuery(Of PersistentClasses.Book)(query).ExecuteBindingList()
		ElseIf RadComboBox1.SelectedValue = "2" Then
			' LINQ statement: from x in scope.Extent<Product>() where x is Book select x;
			query = "SELECT * FROM ProductExtent AS p WHERE (p IN BookExtent)"
			queryResult = scope.GetOqlQuery(Of PersistentClasses.Product)(query).ExecuteBindingList()
		End If

		RadGrid1.DataSource = queryResult
	End Sub

	Protected Sub RadComboBox1_SelectedIndexChanged(ByVal o As Object, ByVal e As Telerik.Web.UI.RadComboBoxSelectedIndexChangedEventArgs)
		RadGrid1.Rebind()
	End Sub
End Class
